local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(959)
do
	local data = {
		version = 12,
		key = "Blackhand",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		--name = L.npc_BlackrockFoundry["Blackhand"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Warlord Blackhand.BLP:35:35",
		respawntime = 29.5,
		triggers = {
			scan = {77325}, 
			encounterid = 1704,
			ejid = 959,
		},
		onactivate = {
			tracing = {
				77325,
				powers={true},
				markers1 = {30,70},				
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1","boss2"},
			defeat = 77325,
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			--timelfr = 600,
			--timeflex = 600,
			--timeheroic = 600,
			--timemythic = 600,
		},
		arrows = {
			MarkedforDeathArrow = {
				varname = SN[156096],
				unit = "&closest|MarkedforDeathunits2&",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[156096],
				range1 = 10,
				range2 = 12,
				range3 = 15,
				desc = 156096,
				icon = ST[156096],
			},
		},
		raidicons = {
			MarkedforDeathmark = {
				varname = SN[156096],
				type = "MULTIFRIENDLY",
				persist = 120,
				unit = "#5#",
				icon = 1,
				total = 5,
				reset = 5,
				desc = 156096,
				icon2 = ST[156096],
			},	
			massiveSmashmark = {
				varname = SN[158054],
				type = "FRIENDLY",
				persist = 7,
				unit = "<tankName>", 
				icon = 6,
				desc = 158054,
				icon2 = ST[158054],
				enabled = false,
			},					
		},		
		timers = {
			timerSmashProximity = {
				{
					"expect",{"<massiveSmashProximity>","==","0"},
					"set",{tankName = "&tft_unitname&"},
					--"debug",{"timerSmashProximity","<tankName>"},
					"invoke",{
						{
							"expect",{"<tankName>","~=","nil"},
							"set",{geticon = "&geticon|<tankName>&"},
							"raidicon","massiveSmashmark",
							"openwindow",{"6","<tankName>",false,158054},
							"set",{massiveSmashProximity = 1},
						},
						{
							"set",{enabletarget = 1},
							"scheduletimer",{"timerCloseSmashProximity",5},
						},
					},
				},
			},	
			timerCloseSmashProximity = {
				{
					"set",{enabletarget = 0},
				},
				{
					"expect",{"<massiveSmashProximity>","==","1"},
					"seticon",{"<tankName>","<geticon>"},
					"set",{tankName = "nil"},
					"set",{geticon = 0},
					"set",{massiveSmashProximity = 0},
					"closewindow",
				},
			},		
			timerMarkedforDeath = {
				{
					"message","mMarkedforDeath",
				},
			},
			timerAttachSlagBombs = {
				{
					"message","mAttachSlagBombs",
				},
			},
		},	
		announces = { 
			MarkedforDeathsay = {
				varname = format(L.alert["%s %s %s!"],SN[156096],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[156096],L.alert["on"],L.alert["Me"]),
				desc = 156096,
				icon = ST[156096],
			},	
			MarkedforDeathsayLeft = {
				varname = format(L.alert["%s - %s!"],SN[156096],L.alert["Left"]),
				type = "SAY",
				msg = format(L.alert["%s - %s!"],SN[156096],L.alert["Left"]),
				desc = 156096,
				icon = ST[156096],
				flashcolor = "RED",
				flashscreen = true,
				sound = "ALERT15",
			},
			MarkedforDeathsayRight = {
				varname = format(L.alert["%s - %s!"],SN[156096],L.alert["Right"]),
				type = "SAY",
				msg = format(L.alert["%s - %s!"],SN[156096],L.alert["Right"]),
				desc = 156096,
				icon = ST[156096],
				flashcolor = "RED",
				flashscreen = true,
				sound = "ALERT15",				
			},
			MarkedforDeathsayMiddle = {
				varname = format(L.alert["%s - %s!"],SN[156096],L.alert["Middle"]),
				type = "SAY",
				msg = format(L.alert["%s - %s!"],SN[156096],L.alert["Middle"]),
				desc = 156096,
				icon = ST[156096],
				flashcolor = "RED",
				flashscreen = true,
				sound = "ALERT15",						
			},			
			AttachSlagBombssayMiddle = {
				varname = format(L.alert["%s - %s!"],SN[157000],L.alert["Middle"]),
				type = "SAY",
				msg = format(L.alert["%s - %s!"],SN[157000],L.alert["Middle"]),
				desc = 157000,
				icon = ST[157000],
				flashcolor = "RED",
				flashscreen = true,
				sound = "ALERT10",
				exlfr = true,
			},
			AttachSlagBombssayBack = {
				varname = format(L.alert["%s - %s!"],SN[157000],L.alert["Back"]),
				type = "SAY",
				msg = format(L.alert["%s - %s!"],SN[157000],L.alert["Back"]),
				desc = 157000,
				icon = ST[157000],
				flashcolor = "RED",
				flashscreen = true,
				sound = "ALERT10",
				exlfr = true,
			},
			AttachSlagBombssay = {
				varname = format(L.alert["%s %s %s!"],SN[157000],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[157000],L.alert["on"],L.alert["Me"]),
				desc = 157000,
				icon = ST[157000],
				exflex = true,
				exheroic = true,
				exmythic = true,				
			},				
			Fixatesay = {
				varname = format(L.alert["%s %s %s!"],SN[156653],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[156653],L.alert["on"],L.alert["Me"]),
				desc = 156653,
				icon = ST[156653],
			},			
		},			
		userdata = {
			phase = 1,
			smashCount = 1,
			markCount = 0,
			bombCount = 0,
			siegemakerCount = 1	,		
			Demolitioncd = 1,
			Demolition = 1,
			massiveSmashProximity = 0,
			ShatteringSmash = 0,
			nextSmash = 0,
			tankName = "nil",
			newTarget = "nil",
			oldIcon = 0,
			enabletarget = 0,
			MarkedforDeathunits = {type = "container", wipein = 3},
			MarkedforDeathunits2 = {type = "container", wipein = 3},
			AttachSlagBombsunits = {type = "container", wipein = 3},
		},		
		messages = {
			mFixate = {
				varname = format(L.alert["%s %s %s"],SN[156653],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[156653],L.alert["on"]),
				color1 = "BROWN",
				sound = "ALERT13",
				desc = 156653,
				icon = ST[156653],
			},		
			mDemolition = {
				varname = format(L.alert["%s (2)"],SN[156425]),
				type = "message",
				text = format(L.alert["%s (<Demolition>)"],SN[156425]),
				text2 = format(L.alert["%s"],SN[156425]),
				color1 = "ORANGE",
				sound = "ALERT11",
				desc = 156425,
				icon = ST[156425],
			},
			mSiegemaker = {
				varname = format(L.alert["%s (2)"],SN["ej9571"]),
				type = "message",
				text = format(L.alert["%s (<siegemakerCount>)"],SN["ej9571"]),
				color1 = "CYAN",
				sound = "ALERT13",
				ability = 9571,
				icon = EJST[9571],
			},			
			mShatteringSmash = {
				varname = format(L.alert["%s (2)"],SN[155992]),
				type = "message",
				text = format(L.alert["%s (<smashCount>)"],SN[155992]),
				color1 = "GOLD",
				sound = "ALERT13",
				desc = 155992,
				icon = ST[155992],
			},	
			mMarkedforDeath = {
				varname = format(L.alert["%s %s %s"],SN[156096],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|MarkedforDeathunits&"],SN[156096],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 156096,
				icon = ST[156096],
			},
			mAttachSlagBombs = {
				varname = format(L.alert["%s %s %s"],SN[157000],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|AttachSlagBombsunits&"],SN[157000],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 157000,
				icon = ST[157000],
			},	
			mThrowSlagBombs = {
				varname = format(L.alert["%s (2)"],SN[156030]),
				type = "message",
				text = format(L.alert["%s"],SN[156030]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 156030,
				icon = ST[156030],
			},
			mBlackironPlatingRemoved = {
				varname = format(L.alert["%s %s"],SN[156667],L.alert["Removed"]),
				type = "message",
				text = format(L.alert["%s %s"],SN[156667],L.alert["Removed"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 156667,
				icon = ST[156667],
			},			
		},
		onstart = {
			{
				"set",{enabletarget = 0},
				"alert",{"ThrowSlagBombsCD", time = 2},
				"alert",{"DemolitionCD", time = 2},
				"alert",{"ShatteringSmashCD", time = 2},
				"alert",{"MarkedforDeathCD", time = 2},
			},
		},
		alerts = {
			DemolitionCD = {
				varname = format(L.alert["Next %s"],SN[156425]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[156425]),
				time = 45.5,
				time2 = 15.5,
				time3 = 30.5,
				color1 = "GLOBAL",
				icon = ST[156425],
				desc = 156425,
			},
			MarkedforDeathCD = {
				varname = format(L.alert["Next %s"],SN[156096]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[156096]),
				time = 15.5,
				time2 = 36,
				time3 = 25,
				time4 = 20.5,
				time5 = 26,
				time6 = 16,
				color1 = "GLOBAL",
				icon = ST[156096],
				desc = 156096,
			},
			ThrowSlagBombsCD = {
				varname = format(L.alert["%s Cooldown"],SN[156030]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156030]),
				time = 25,
				time2 = 6,
				time3 = 12,
				color1 = "GLOBAL",
				icon = ST[156030],
				desc = 156030,
			},
			ShatteringSmashCD = {
				varname = "(2) "..format(L.alert["%s Cooldown"],SN[155992]),
				type = "dropdown",
				text = "(<smashCount>) "..format(L.alert["%s Cooldown"],SN[155992]),
				time = 45,
				time2 = 21,
				time3 = 30,
				time4 = 24.5,
				time5 = 26,
				time6 = "<nextSmash>",
				time7 = 18.5,
				time8 = 22,
				time9 = 6,
				time10 = 35,
				color1 = "GLOBAL",
				icon = ST[155992],
				desc = 155992,
			},
			MassiveShatteringSmashCD = {
				varname = "(2) "..format(L.alert["Next %s"],SN[158054]),
				type = "dropdown",
				text = "(<smashCount>) "..format(L.alert["Next %s"],SN[158054]),
				time = 25,
				color1 = "GLOBAL",
				icon = ST[158054],
				desc = 158054,
			},			
			SiegemakerCD = {
				varname = "(2) "..format(L.alert["Next %s"],SN["ej9571"]),
				type = "dropdown",
				text = "(<siegemakerCount>) "..format(L.alert["Next %s"],SN["ej9571"]),
				time = 50,
				time2 = 16,
				color1 = "GLOBAL",
				icon = ST[156667],
				ability = 9571,
			},
			SlagEruptionCD = {
				varname = format(L.alert["%s Cooldown"],SN[156928]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156928]),
				time = 32.5,
				time2 = 31.5,
				time3 = 33,
				color1 = "GLOBAL",
				icon = ST[156928],
				desc = 156928,
				counter = true,
			},
			AttachSlagBombsCD = {
				varname = format(L.alert["%s Cooldown"],SN[157000]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[157000]),
				time = 25.5,
				time2 = 11,
				time3 = 12,
				time4 = 25,
				color1 = "GLOBAL",
				icon = ST[157000],
				desc = 157000,
			},	
			FallingDebrisCD = {
				varname = format(L.alert["%s Cooldown"],SN[162585]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[162585]),
				time = 40,
				time2 = 12,
				color1 = "GLOBAL",
				icon = ST[162585],
				desc = 162585,
			},
			ImpalingThrowCD = {
				varname = format(L.alert["%s Cooldown"],SN[156107]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156107]),
				time = 40,
				color1 = "GLOBAL",
				icon = ST[156107],
				desc = 156107,
			},
			-- Warning
			wSlagEruption = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[156928]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[156928]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[156928],
				sound = "ALERT13",
				desc = 156928,
			},	
			wMassiveShatteringSmash = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[158054]),
				type = "simple",
				text = format(L.alert["%s %s (<smashCount>)"],L.alert["Incoming"],SN[158054]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[158054],
				sound = "ALERT13",
				desc = 158054,
			},	
			wSlagEruption = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[156928]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[156928]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[156928],
				sound = "ALERT13",
				desc = 156928,
			},
			wMassiveExplosion = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[163008]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[163008]),
				time = 2,
				color1 = "RED",
				icon = ST[163008],
				sound = "ALERT15",
				desc = 163008,
			},			
			Phase2 = {
				varname = format(L.alert["Phase 2"]),
				type = "simple",
				text = format(L.alert["Phase 2"]),
				time = 2,
				color1 = "YELLOW",
				icon = EJST[9571],
				sound = "ALERT13",
			},
			Phase3 = {
				varname = format(L.alert["Phase 3"]),
				type = "simple",
				text = format(L.alert["Phase 3"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[161348],
				sound = "ALERT13",
			},		
			-- Inform
			iFixate = {
				varname = format(L.alert["%s %s %s!"],SN[156653],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[156653],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[156653],
				sound = "ALERT12",
				desc = 156653,
				flashscreen = true,
			},
			iMarkedforDeath = {
				varname = format(L.alert["%s %s %s!"],SN[156096],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[156096],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[156096],
				sound = "ALERT15",
				desc = 156096,
				flashscreen = true,			
			},				
			iMoltenSlag = {
				varname = format(L.alert["%s %s, %s!"],SN[156401],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[156401],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[156401],
				sound = "ALERT12",
				desc = 156401,
				flashscreen = true,
				throttle = 2,
			},			
			-- Casts
			DemolitionActive = {
				varname = "(2) "..format(L.alert["%s Active"],SN[156479]),
				type = "centerpopup",
				text = "(<Demolition>) "..format(L.alert["%s Active"],SN[156479]),
				time = 6,
				color1 = "RED",
				icon = ST[156479],
				desc = 156479,
			},
			FallingDebrisActive = {
				varname = format(L.alert["%s Active"],SN[162585]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[162585]),
				time = 6,
				color1 = "ORANGE",
				icon = ST[162585],
				desc = 162585,
			},			
			ImpalingThrowCast = {
				varname = format(L.alert["%s Active"],SN[156107]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[156107]),
				time = 5,
				color1 = "RED",
				icon = ST[156107],
				desc = 156107,
			},
			AttachSlagBombsCast = {
				varname = format(L.alert["%s Active"],SN[157000]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[157000]),
				time = 5,
				color1 = "RED",
				icon = ST[157000],
				desc = 157000,
			},
			MassiveExplosionCast = {
				varname = format(L.alert["%s Casting"],SN[163008]),
				type = "centerpopup",
				text = format(L.alert["%s Casting"],SN[163008]),
				time = 5,
				color1 = "RED",
				icon = ST[163008],
				desc = 163008,
				audiocd = true,
				audiotime = 5,
			},
			-- Debuff
			AttachSlagBombsDebuff = {
				varname = format(L.alert["%s Debuff"],SN[157000]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[157000]),
				text2 = format(L.alert["#5#: %s"],SN[157000]),
				time = 5,
				color1 = "RED",
				desc = 157000,
				icon = ST[157000],
				tag = "#5#",
				exdps = true,		
			},			
		},
		events = {
			-- ShatteringSmash 
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {155992,159142},
				execute = {
					{
						"message","mShatteringSmash",
						"set",{smashCount = "INCR|1"},
					},
					{
						"expect",{"<phase>","==","2"},
						"alert","ShatteringSmashCD",
					},
					{
						"expect",{"&mythic&","==","true"},
						"alert",{"ShatteringSmashCD", time = 3},
					},					
					{
						"expect",{"<phase>","~=","2"},
						"alert",{"ShatteringSmashCD", time = 3},
						"invoke",{
							{
								"expect",{"<phase> <smashCount>","==","1 2"},
								"alert",{"ShatteringSmashCD", time = 10},
							},
						},
					},
				},
			},	
			-- MarkedforDeath
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156096},
				execute = {
					{
						"insert",{"MarkedforDeathunits","#5#"},
						"insert",{"MarkedforDeathunits2","#5#",true},
						"set",{markCount = "INCR|1"},
						"invoke",{
							{
								"expect",{"&count|MarkedforDeathunits2&","==","1"},
								"canceltimer","timerMarkedforDeath",
								"scheduletimer",{"timerMarkedforDeath",0.2},
								"alert","ImpalingThrowCast",
								--"set",{markCount = "INCR|1"},
								"invoke",{
								--	{
								--		"expect",{"&mythic&","==","false"},
								--		"expect",{"<markCount>",">","3"},
								--		"set",{markCount = 1},
								--	},
									{
										"expect",{"<phase>","~=","3"},
										"alert",{"MarkedforDeathCD", time = 6},
									},
									{
										"expect",{"<phase>","==","3"},
										"alert",{"MarkedforDeathCD", time = 4},
									},
									{
										"expect",{"&timeleft|ShatteringSmashCD|0&","<","6"},
										"alert",{"ShatteringSmashCD", time = 9},
									},
								},
							},
						},
					},	
					{
						"expect",{"&mythic&","==","false"},
						"expect",{"<markCount>",">","2"}, -- 2 on all expect mythic
						"set",{markCount = 1},
					},
					{
						"expect",{"&mythic&","==","true"},
						"expect",{"<markCount>",">","3"}, -- 3 on mythic
						"set",{markCount = 1},
					},				
					{
						"expect",{"#4#","==","&playerguid&"},
						"invoke",{
							{
								"expect",{"<phase>","==","3"},
								"invoke",{
									{
										"expect",{"<markCount>","==","1"},
										"announce","MarkedforDeathsayLeft",
									},
									{
										"expect",{"<markCount>","==","2"},
										"announce","MarkedforDeathsayRight",
									},
									{
										"expect",{"<markCount>","==","3"},
										"announce","MarkedforDeathsayMiddle",
									},
								},
							},
							{
								"expect",{"<phase>","~=","3"},
								"announce","MarkedforDeathsay",
								"alert","iMarkedforDeath",
							},
						},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"arrow","MarkedforDeathArrow",
					},
					{
						"expect",{"<phase>","~=","3"},
						"alert","MarkedforDeathCD",
					},
					{
						"expect",{"<phase>","==","3"},
						"alert",{"MarkedforDeathCD", time = 4},
					},	
					{
						"raidicon","MarkedforDeathmark",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {156096},
				dstisplayerunit = true,
				execute = {
					{
						"quash","ImpalingThrowCast",
						"removeraidicon","#5#",
					},	
				},
			},
			-- MoltenSlag
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156401},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMoltenSlag",
					},					
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {156401},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMoltenSlag",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {156401},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMoltenSlag",
					},
				},
			},
			-- Siegemaker
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {156667},
				execute = {
					{
						"message","mSiegemaker",
						"set",{siegemakerCount = "INCR|1"},
						"alert","SiegemakerCD",
						"tracing",{
							77325,
							77342,
							powers={true,true},
							markers1 = {30,70},		
						},
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {156667},
				execute = {
					{
						"message","mBlackironPlatingRemoved",
					},	
				},
			},	
			-- Fixate
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156653},
				execute = {
					{
						"message","mFixate",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","Fixatesay",
						"alert","iFixate",
					},					
				},
			},
			-- SlagEruption
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156928},
				execute = {
					{
						"alert","wSlagEruption",
						"alert",{"SlagEruptionCD", time = 3},
					},			
				},
			},	
			-- MassiveShatteringSmash
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {158054},
				execute = {
					{
						"alert","wMassiveShatteringSmash",
						"set",{smashCount = "INCR|1"},
						"alert","MassiveShatteringSmashCD",
					},			
				},
			},				
			-- SmashReschedule
			{
				type = "combatevent",
				eventtype = "SPELL_ENERGIZE",
				spellid = {104915},
				dstnpcid = 77325,
				execute = {
					{
						"set",{nextSmash = "&getup|boss1&"},
						"alert",{"ShatteringSmashCD", time = 6},
					},			
				},
			},	
			-- AttachSlagBombs
			--[[{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {157000, 159179},
				execute = {
					{
						"insert",{"AttachSlagBombsunits","#5#"},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","AttachSlagBombsCast",
						"alert","AttachSlagBombsDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"AttachSlagBombsDebuff", text = 2},
					},
					{
						"expect",{"&count|AttachSlagBombsunits&","==","1"},
						"canceltimer","timerAttachSlagBombs",
						"scheduletimer",{"timerAttachSlagBombs",1},	
						"alert",{"AttachSlagBombsCD", time = 4},
					},
				},
			},--]]
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {157000},
				execute = {
					{
						"insert",{"AttachSlagBombsunits","#5#"},
						"set",{bombCount = "INCR|1"},
					},
					{
						"expect",{"<bombCount>",">","2"},
						"set",{bombCount = 1},
					},					
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","AttachSlagBombsCast",
						"alert","AttachSlagBombsDebuff",			
						"openwindow",{"10",nil,false,157000},
						"invoke",{
							{
								"expect",{"<bombCount>","==","1"},
								"announce","AttachSlagBombssayMiddle",
							},
							{
								"expect",{"<bombCount>","==","2"},
								"announce","AttachSlagBombssayBack",
							},
						},
					},	
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"AttachSlagBombsDebuff", text = 2},
					},
					{
						"expect",{"&count|AttachSlagBombsunits&","==","1"},
						"canceltimer","timerAttachSlagBombs",
						"scheduletimer",{"timerAttachSlagBombs",1.8},	
						"alert",{"AttachSlagBombsCD", time = 4},
					},	
					{
						"expect",{"&count|AttachSlagBombsunits&","==","3"},
						"canceltimer","timerAttachSlagBombs",
						"scheduletimer",{"timerAttachSlagBombs",0.1},	
					},						
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {159179},  -- Throw Slag Bombs
				--dstisplayerunit = true,
				execute = {
					{
						"insert",{"AttachSlagBombsunits","#5#"},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","AttachSlagBombssay",
						"alert","AttachSlagBombsCast",
						"alert","AttachSlagBombsDebuff",	
						"openwindow",{"10",nil,false,159179},						
						
					},	
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"AttachSlagBombsDebuff", text = 2},
					},	
					{
						"expect",{"&count|AttachSlagBombsunits&","==","1"},
						"canceltimer","timerAttachSlagBombs",
						"scheduletimer",{"timerAttachSlagBombs",1.8},	
						"alert",{"AttachSlagBombsCD", time = 4},
					},		
					{
						"expect",{"&count|AttachSlagBombsunits&","==","3"},
						"canceltimer","timerAttachSlagBombs",
						"scheduletimer",{"timerAttachSlagBombs",0.1},	
					},						
				},
			},			
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {157000, 159179},
				execute = {
					{
						"quash","AttachSlagBombsDebuff",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"quash","AttachSlagBombsCast",
						"closewindow",
					},
				},
			},
			-- SlagEruption
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156928},
				execute = {
					{
						"alert",{"SlagEruptionCD", time = 3},
						"alert","wSlagEruption",
					},			
				},
			},
			-- MassiveExplosion
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {163008},
				execute = {
					{
						"batchalert",{"wMassiveExplosion","MassiveExplosionCast"},
					},			
				},
			},	
			-- FallingDebris
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {162579},
				execute = {
					{
						"message","mFallingDebris",
						"batchalert",{"FallingDebrisCD","FallingDebrisActive"},
					},			
				},
			},					
		---------------------
			{
				type = "event",
				event = "UNIT_TARGET",
				execute = {
					{
						"expect",{"<enabletarget>","==","1"},
						"expect",{"#1#","~=","0"},
						"invoke",{
							{
								"set",{newTarget = "&tft_unitname&"},
								"invoke",{
									{
										"expect",{"<newTarget>","~=","nil"},
										--"debug",{"unit_target","<newTarget>"},
										"expect",{"&istargettank|<newTarget>|boss1&","==","true"},
										"invoke",{
											{
												"expect",{"<tankName>","==","nil"},
												"set",{tankName = "<newTarget>"},
												"set",{geticon = "&geticon|<tankName>&"},
												"raidicon","massiveSmashmark",
											},
											{
												"expect",{"<tankName>","~=","nil"},
												"invoke",{
													{
														"expect",{"<tankName>","~=","<newTarget>"},
														"seticon",{"<tankName>","<geticon>"},
														"set",{tankName = "<newTarget>"},
														"set",{geticon = "&geticon|<tankName>&"},
														"raidicon","massiveSmashmark",
														"openwindow",{"6","<tankName>",false,158054},
														--"debug",{"UNIT_TARGET","<tankName>"},
														"set",{massiveSmashProximity = 1},
													},
												},
											},
										},
									},
								},
							},																		
						},
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","77342"}, --siege
						"tracing",{
							77325,
							powers={true},
							markers1 = {30,70},
						},
					},
				},
			},
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED", 
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","156991"}, -- ThrowSlagBombs
								"expect",{"<phase>","<","3"},
								"invoke",{
									{
										"expect",{"&istank&","==","true"},
										"alert","iThrowSlagBombs",
										--"batchalert",{"ThrowSlagBombsCD","iThrowSlagBombs"},
									},
									{
										"expect",{"&ismelee&","==","true"},
										"alert","iThrowSlagBombs",
										--"batchalert",{"ThrowSlagBombsCD","iThrowSlagBombs"},
									},
									{
										"alert","ThrowSlagBombsCD",
										"message","mThrowSlagBombs",
									},
								},
							},
							{
								"expect",{"#5#","==","156425"}, -- Demolition
								"message",{"mDemolition", text = 2},
								"set",{Demolition = 1},
								"invoke",{
									{
										"expect",{"&mythic&","==","true"},
										"set",{Demolition = 2},
										"schedulealert",{"DemolitionActive",3},	
										"schedulemessage",{"mDemolition",3},
										"schedulealert",{"DemolitionActive",6},	
										"schedulemessage",{"mDemolition",6},	
										"schedulealert",{"DemolitionActive",9},	
										"schedulemessage",{"mDemolition",9},
										"alert",{"DemolitionCD", time = 3},
									},
									{
										"expect",{"&mythic&","==","false"},
										"schedulealert",{"DemolitionActive",5},	
										"schedulealert",{"DemolitionActive",10},	
										"alert","DemolitionCD",
									},
								},
							},	
							{
								"expect",{"#5#","==","161347"}, -- Jump To Second Floor
								"set",{smashCount = 1},
								"set",{markCount = 0},
								"set",{siegemakerCount = 1},
								"alert",{"ThrowSlagBombsCD", time = 3},
								"alert",{"SiegemakerCD", time = 2},
								"alert",{"MarkedforDeathCD", time = 5},
								"invoke",{
									{
										"expect",{"&mythic&","==","true"},
										"alert",{"ShatteringSmashCD", time = 7},
									},
									{
										"expect",{"&mythic&","==","false"},
										"alert",{"ShatteringSmashCD", time = 8},
									},
									{
										"expect",{"&lfr&","==","false"},
										"expect",{"&isranged&","==","true"},
										"openwindow",{"7"},
									},										
								},
							},	
							{
								"expect",{"#5# <phase>","==","158021 1"}, -- starting p2
								"batchquash",{"ThrowSlagBombsCD","DemolitionCD","ImpalingThrowCD","MarkedforDeathCD"},
								"set",{phase = 2},
								"alert","Phase2",
							},	
							{
								"expect",{"#5#","==","161348"}, -- Jump To Third Floor
								"quash","ShatteringSmashCD",
								"set",{smashCount = 1, phase = 3},
								"batchquash",{"ThrowSlagBombsCD","SiegemakerCD","ImpalingThrowCD","MarkedforDeathCD"},
								"alert","Phase3",
								"alert",{"AttachSlagBombsCD", time = 3},
								"alert",{"MarkedforDeathCD", time = 6},
								"alert",{"ShatteringSmashCD", time = 5},
								"alert",{"SlagEruptionCD", time = 2},
								"scheduletimer",{"timerSmashProximity",23},
								"invoke",{
									{
										"expect",{"&mythic&","==","true"},
										"alert",{"FallingDebrisCD", time = 2},
									},
									{
										"expect",{"&lfr&","==","false"},
										"expect",{"&isranged&","==","true"},
										"closewindow",
									},		
								},
							},							
						},
					},
				},
			},			
		},
	}

	DXE:RegisterEncounter(data)
end