local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST
local EJName = EJ_GetEncounterInfo(1128)
do
	local data = {
		version = 5,
		key = "KargathBladefist",
		zone = L.zone["Highmaul"],
		category = L.zone["Highmaul"],
		--name = L.npc_Highmaul["Kargath Bladefist"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Kargath Bladefist.BLP:35:35",
		triggers = {
			scan = {78714}, 
			encounterid = {1721},
			ejid = {1128},
		},
		onactivate = {
			tracing = {78714}, -- 80474
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1","boss2"},
			defeat = 78714,
		},
		windows = {
			proxwindow = true,
			proxrange = 4,
		},
		timers = {
			timerChainHurl = {
				{
					"message","mChainHurl",
				},
			},
		},		
		userdata = {
			ChainHurlunists = {type = "container", wipein = 3},
			OpenWoundscount = 0,
		},
		arrows = {
			BerserkerRusharrow = {
				varname = SN[158986],
				unit = "#5#", --&upvalue&
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[158986],
				range1 = 10,
				range2 = 12,
				range3 = 14,
				desc = 158986,
				icon = ST[158986],
			},
		},	
		raidicons = {
			BerserkerRushmark = {
				varname = SN[158986],
				type = "FRIENDLY",
				persist = 60,
				unit = "#5#", --&upvalue&
				icon = 1,
				desc = 158986,
				icon2 = ST[158986],
			},
			OnTheHuntmark = {
				varname = SN[162497],
				type = "FRIENDLY",
				persist = 60,
				unit = "#5#", --&upvalue&
				icon = 2,
				desc = 162497,
				icon2 = ST[162497],
			},
		},			
		announces = { 
			BerserkerRushsay = {
				varname = format(L.alert["%s %s %s!"],SN[158986],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[158986],L.alert["on"],L.alert["Me"]),
				desc = 158986,
				icon = ST[158986],
			},	
			OnTheHuntsay = {
				varname = format(L.alert["%s %s %s!"],SN[162497],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[162497],L.alert["on"],L.alert["Me"]),
				desc = 162497,
				icon = ST[162497],
			},				
		},		
		messages = {
			mChainHurl = {
				varname = format(L.alert["%s %s %s"],SN[159947],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|ChainHurlunists&"],SN[159947],L.alert["on"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 159947,
				icon = ST[159947],
			},	
			mImpale = {
				varname = format(L.alert["%s %s %s"],SN[159113],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[159113],L.alert["on"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 159113,
				icon = ST[159113],
			},
			mBerserkerRush = {
				varname = format(L.alert["%s %s %s"],SN[158986],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[158986],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 158986,
				icon = ST[158986],
			},
			mOpenWounds = {
				varname = format(L.alert["%s %s %s (2)"],SN[159178],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s %s (1)"],SN[159178],L.alert["on"],L.alert["player"]),
				text2 = format(L.alert["%s %s %s (#11#)"],SN[159178],L.alert["on"],L.alert["player"]),
				color1 = "YELLOW",
				icon = ST[159178],
				desc = 159178,
				sound = "ALERT13",
				exhealer = true,
				exdps = true,
			},
			mOnTheHunt = {
				varname = format(L.alert["%s %s %s"],SN[162497],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[162497],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 162497,
				icon = ST[162497],
			},
			mPillar = {
				varname = format(L.alert["%s!"],SN["ej9394"]),
				type = "message",
				text = format(L.alert["%s!"],SN["ej9394"]),
				color1 = "ORANGE",
				icon = ST[159202],
				sound = "ALERT13",
				ability = 9394,
			},			
		},
		onstart = {
			{
				"alert","PillarCD",
				--"alert",{"PillarCD", time = 2},
				"alert",{"BerserkerRushCD", time = 2},
				"alert",{"ChainHurlCD", time = 2},
				"alert",{"ImpaleCD", time = 2},
			},
			{
				"expect",{"&mythic&","==","true"},
				"alert","TigerCD",
			},
		},
		alerts = {
			PillarCD = {
				varname = format(L.alert["%s Cooldown"],SN["ej9394"]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN["ej9394"]),
				time = 20,
				time2 = 24,
				color1 = "GLOBAL",
				icon = ST[159202],
				ability = 9394,				
			},	
			ChainHurlCD = {
				varname = format(L.alert["%s Cooldown"],SN[159947]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[159947]),
				time = 106,
				time2 = 90,
				color1 = "GLOBAL",
				icon = ST[159947],
				desc = 159947,	
				audiocd = true,
				audiotime = 10,				
			},	
			SweeperCD = {
				varname = format(L.alert["%s Cooldown"],SN[177776]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[177776]),
				time = 55,
				color1 = "GLOBAL",
				icon = ST[177258],
				desc = 177776,
				--audiocd = true,
				--audiotime = 8,				
			},
			BerserkerRushCD = {
				varname = format(L.alert["%s Cooldown"],SN[158986]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[158986]),
				time = 46,
				time2 = 54,
				color1 = "GLOBAL",
				icon = ST[158986],
				desc = 158986,
				biggerbar = true,	
			},	
			ImpaleCD = {
				varname = format(L.alert["%s Cooldown"],SN[159113]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[159113]),
				time = 43,
				time2 = 37,
				color1 = "GLOBAL",
				icon = ST[159113],
				desc = 159113,
				--exhealer = true,
				exdps = true,
				audiocd = true,
				audiotime = 7,
			},	
			TigerCD = {
				varname = format(L.alert["%s Cooldown"],SN["ej9396"]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN["ej9396"]),
				time = 110,
				color1 = "GLOBAL",
				icon = ST[162497],
				ability = 9396,	
				audiocd = true,
				audiotime = 5,
				extank = true,
			},
			-- Warning
			wChainHurl = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[159947]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[159947]),
				time = 2,
				color1 = "GREEN",
				icon = ST[159947],
				sound = "ALERT14",
				desc = 159947,
			},
			wBerserkerRushEnded = {
				varname = format(L.alert["%s %s!"],SN[158986],L.alert["Over"]),
				type = "simple",
				text = format(L.alert["%s %s!"],SN[158986],L.alert["Over"]),
				time = 2,
				color1 = "GREEN",
				icon = ST[158986],
				sound = "ALERT13",
				desc = 158986,
			},			
			-- Inform
			iImpale = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[159113]),
				type = "inform",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[159113]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[159113],
				sound = "ALERT10",
				desc = 159113,
				exhealer = true,
				exdps = true,
			},
			iBerserkerRush = {
				varname = format(L.alert["%s!!!"],L.chat_Highmaul["MOVE TO PILLAR OF FLAMES"]),
				type = "inform",
				text = format(L.alert["%s!!!"],L.chat_Highmaul["MOVE TO PILLAR OF FLAMES"]),
				time = 2,
				color1 = "RED",
				icon = ST[162497],
				sound = "ALERT12",
				desc = 162497,
			},
			iOpenWounds = {
				varname =  format(L.alert["%s - %s!"],SN[159178],L.alert["Removed"]),
				type = "inform",
				text = format(L.alert["%s - %s!"],SN[159178],L.alert["Removed"]),
				time = 2,
				color1 = "INDIGO",
				sound = "ALERT10",
				icon = ST[159178],
				exdps = true,
				desc = 159178,
				exhealer = true,
				exdps = true,
			},			
			iOpenWoundsself = {
				varname = format(L.alert["%s: %s 12 %s!"],SN[159178],L.alert["already at"],L.alert["Stacks"]),
				type = "inform",
				text = format(L.alert["%s: %s #11# %s!"],SN[159178],L.alert["already at"],L.alert["Stacks"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT14",
				icon = ST[159178],
				desc = 159178,
				flashscreen = true,
				exdps = true,
				exhealer = true,
			},
			iOnTheHunt = {
				varname = format(L.alert["%s %s %s, %s %s!"],SN[162497],L.alert["on"],L.alert["YOU"],L.alert["GO TO"],"&ej_getspellinfo!9394&"),
				type = "inform",
				text = format(L.alert["%s %s %s, %s %s!"],SN[162497],L.alert["on"],L.alert["YOU"],L.alert["GO TO"],"&ej_getspellinfo!9394&"),
				time = 2,
				color1 = "RED",
				icon = ST[162497],
				sound = "ALERT11",
				desc = 162497,
				flashscreen = true,
			},
			iMaulingBrewAway = {
				varname = format(L.alert["%s %s, %s!"],SN[159413],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[159413],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[159413],
				sound = "ALERT10",
				desc = 159413,
				flashscreen = true,
			},
			iFlameJetAway = {
				varname = format(L.alert["%s %s, %s!"],SN[159311],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[159311],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[159311],
				sound = "ALERT10",
				desc = 159311,
				flashscreen = true,
			},	
			-- Casts
			ImpaleCast = {
				varname = format(L.alert["%s Active"],SN[159113]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[159113]),
				time = 8.8,
				color1 = "ORANGE",
				icon = ST[159113],
				desc = 159113,
			},					
			-- Debuff 
			OpenWoundsDebuff = {
				varname = format(L.alert["%s Debuff"],SN[159178]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[159178]),
				text2 = format(L.alert["#5# (1): %s"],SN[159178]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[159178]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[159178]),
				time = 60,
				color1 = "PURPLE",
				desc = 159178,
				icon = ST[159178],
				tag = "#5#",
				exdps = true,				
			},			
		},
		events = {
			-- Impale
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {159113},
				execute = {
					{
						"target",{
							source = "#1#",
							wait = 0.5,
							schedule = 1,
							message = "mImpale",
							--announce = "",
							alerts = {
								--self = "",
								other = "ImpaleCast",
							},
						},
					},
					{
						"batchalert",{"ImpaleCD","iImpale"},
						--"message","mImpale",
					},
				},
			},
			-- ChainHurl
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {159947},
				execute = {
					{
						"batchalert",{"ChainHurlCD","wChainHurl"},
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {159947},
				execute = {
					{
						"insert",{"ChainHurlunists","#5#"},
						"canceltimer","timerChainHurl",
						"scheduletimer",{"timerChainHurl",0.5},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","SweeperCD",
					},				
				},
			},
			-- BladeDance
			--[[{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {159250},
				execute = {
					{
						-- spammy
					},			
				},
			},--]]
			-- BerserkerRush
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {158986},
				execute = {
					{
						"alert","BerserkerRushCD",
					},
					{
						"target",{
							source = "#1#",
							wait = 0.5,
							schedule = 1,
							raidicon = "BerserkerRushmark",
							message = "mBerserkerRush",
							announce = "BerserkerRushsay",
							arrow = "BerserkerRusharrow",
							alerts = {
								self = "iBerserkerRush",
							},
						},
					},
				},
			},	
			--[[{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {158986},
				execute = {
					{
						"alert","BerserkerRushCD",
						"message","mBerserkerRush",
						"raidicon","BerserkerRushmark",
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iBerserkerRush",
						"announce","BerserkerRushsay",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"arrow","BerserkerRusharrow",
					},						
				},
			},--]]
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {158986},
				execute = {
					{
						"removeraidicon","#5#",
					},						
				},
			},	
			-- OpenWounds
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {159178},
				execute = {
					{
						"message","mOpenWounds",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","OpenWoundsDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"OpenWoundsDebuff", text = 2},
					},
				},
			},			
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {159178},
				execute = {
					{
						"message",{"mOpenWounds", text = 2},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"OpenWoundsDebuff", text = 3},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"OpenWoundsDebuff", text = 4},
					},
					{
						"expect",{"#11#",">=","2"},
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","iOpenWoundsself",
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"expect",{"&unitisdead|player&","==","0"},
								"expect",{"&playerdebuff|"..SN[159178].."&","==","false"},
								"alert","iOpenWounds",	
							},							
						},
					},
				},
			},
			-- Pillar
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {159202},
				execute = {
					{
						"message","mPillar",
						"alert","PillarCD",
					},
				},
			},
			-- OnTheHunt
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {162497},
				execute = {
					{
						"message","mOnTheHunt",
						"raidicon","OnTheHuntmark"
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iOnTheHunt",
						"announce","OnTheHuntsay",
					},
				},
			},	
			-- MaulingBrew
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {159413},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMaulingBrewAway",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_ABSORBED",
				spellid = {159413},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMaulingBrewAway",
					},
				},
			},
			-- FlameJet
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {159311},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFlameJetAway",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_ABSORBED",
				spellid = {159311},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFlameJetAway",
					},
				},
			},			
			-----
			-- Emotes
			{
				type = "event",
				event = "EMOTE", 
				execute = {
					-- Tiger
					{
						"expect",{"&mythic&","==","true"},
						"alert","TigerCD",
					},
				},
			},
			{
				type = "event",
				event = "UNIT_SPELLCAST_CHANNEL_STOP",
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","158986"}, -- BerserkerRushEnded
								"alert","wBerserkerRushEnded",
							},								
						},
					},
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end