local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

do
	local data = {
		version = 3,
		key = "Ranjit",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["Skyreach: Ranjit"],
		triggers = {
			scan = {75964,}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1", 	},
			unittracing = {	"boss1",},
			defeat = 75964,
		},
		userdata = {

		},		
		messages = {
			mPiercingRush = {
				varname = format(L.alert["%s %s %s"],SN[165731],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[165731],L.alert["on"]),
				color1 = "PURPLE",
				sound = "ALERT13",
				desc = 165731,
				icon = ST[165731],
			},
		},
		onstart = {
			{
				"alert","FourWindsCD",
			},
		},
		alerts = {
			FourWindsCD = {
				varname = format(L.alert["%s Cooldown"],SN[156793]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156793]),
				time = 30,
				color1 = "GLOBAL",
				icon = ST[156793],
				desc = 156793,
			},		
			-- Warning
			wSpinningBlade = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[153544]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[153544]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[153544],
				sound = "ALERT11",
				desc = 153544,
			},
			wFourWinds = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[156793]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[156793]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[156793],
				sound = "ALERT11",
				desc = 156793,
			},	
			wWindFall = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[153315]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[153315]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[153315],
				sound = "ALERT11",
				desc = 153315,
			},
			-- Inform
			iLensFlareAway = {
				varname = format(L.alert["%s %s, %s!"],SN[154043],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[154043],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[154043],
				sound = "ALERT11",
				desc = 153759,
				flashscreen = true,
				throttle = 2,
			},
			iWindFallMoveAway = {
				varname = format(L.alert["%s %s, %s!"],SN[153759],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[153759],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[153759],
				sound = "ALERT10",
				desc = 153759,
				flashscreen = true,
				throttle = 2,
			},
			-- Casts
			FourWindsCast = {
				varname = format(L.alert["%s %s"],SN[156793],L.alert["Active"]),
				type = "centerpopup",
				text = format(L.alert["%s %s"],SN[156793],L.alert["Active"]),
				time = 18,
				flashtime = 18,
				color1 = "RED",
				icon = ST[156793],
			},			
		},
		events = {
			-- SpinningBlade
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {153544},
				execute = {
					{
						"alert","wSpinningBlade",
					},
				},
			},
			-- FourWinds
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156793},
				execute = {
					{
						"batchalert",{"FourWindsCD","FourWindsCast","wFourWinds"},
					},
				},
			},			
			-- WindFall
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {153315},
				execute = {
					{
						"alert","wWindFall",
					},
				},
			},
			-- PiercingRush
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {165731},
				execute = {
					{
						"message","mPiercingRush",
					},
				},
			},	
			-- LensFlare
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {154043},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iLensFlareAway",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_ABSORBED",
				spellid = {154043},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iLensFlareAway",
					},
				},
			},
			-- WindFallMove
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {153759},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iWindFallMoveAway",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_ABSORBED",
				spellid = {153759},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iWindFallMoveAway",
					},
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end