local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

do
	local data = {
		version = 2,
		key = "Tharbek",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["UBRS: Tharbek"],
		triggers = {
			scan = {79912, 80098,}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	79912, 80098, 	},
			unittracing = {	"boss1","boss2"},
			defeat = {	79912, 80098, 	}
		},
		userdata = {
			DBMReset = 0,
		},
		timers = {
			timerDBMSyncReset  = {
				{
					"set",{DBMReset = "0"},	
				},
			},				
		},		
		announces = { 
			ImbuedIronAxesay = {
				varname = format(L.alert["%s %s %s!"],SN[162090],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[162090],L.alert["on"],L.alert["Me"]),
				desc = 162090,
			},		
		},			
		messages = {
			mImbuedIronAxe = {
				varname = format(L.alert["%s %s %s"],SN[162090],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[162090],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 162090,
				icon = ST[162090],			
			},
		},
		onstart = {

		},
		alerts = {
			IronReaverCD = {
				varname = format(L.alert["%s Cooldown"],SN[161989]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[161989]),
				time = 20.5,
				color1 = "GLOBAL",
				icon = ST[161989],
				desc = 161989,
			},
			ImbuedIronAxeCD = {
				varname = format(L.alert["%s Cooldown"],SN[162090]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[162090]),
				time = 29,
				color1 = "GLOBAL",
				icon = ST[162090],
				desc = 162090,
			},
			-- Warning
			wIronReaver = {
				varname = format(L.alert["%s!"],SN[161989]),
				type = "simple",
				text = format(L.alert["%s!"],SN[161989]),
				time = 2,
				color1 = "TAN",
				icon = ST[161989],
				sound = "ALERT10",
				desc = 161989,
			},				
			-- Inform
			iImbuedIronAxe = {
				varname = format(L.alert["%s %s %s!"],SN[157039],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[157039],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[157039],
				desc = 157039,
			},
			iNoxiousSpit = {
				varname = format(L.alert["%s %s, %s!"],SN[161833],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "simple",
				text = format(L.alert["%s %s, %s!"],SN[161833],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[161833],
				flashscreen = true,
				throttle = 3,
				desc = 161833,
			},				
		},
		events = {
			-- ImbuedIronAxe
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {162090},
				execute = {
					{
						"message","mImbuedIronAxe",
						"alert","ImbuedIronAxeCD",
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","ImbuedIronAxesay",
						"alert","iImbuedIronAxe",
					},					
				},
			},
			-- NoxiousSpit
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {161833},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iNoxiousSpit",
					},				
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {161833},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iNoxiousSpit",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {161833},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iNoxiousSpit",
					},
				},
			},

			---------------
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED",
				execute = {
					{
						"expect",{"#5#","==","161989"}, -- IronReaver
						"expect",{"#1#","==","boss1"},
						"dbmsync",{"IronReaver"},
					},				
				},
			},		
			{
				type = "event",
				event = "CHAT_MSG_ADDON", 
				execute = {
					{
						"expect",{"#1#","==","D4"},
						"expect",{"<DBMReset>","~=","1"},
						"set",{DBMReset = "1"},
						"invoke",{
							{
								"expect",{"&sync|DBM|#2#&","==","IronReaver"},
								"batchalert",{"IronReaverCD","wIronReaver"},
							},
							{
								"scheduletimer",{"timerDBMSyncReset",3},							
							},
						},
					},					
				},
			},		
		},
	}

	DXE:RegisterEncounter(data)
end